Index: /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/OBC/obcini.F90
===================================================================
--- /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/OBC/obcini.F90	(revision 2796)
+++ /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/OBC/obcini.F90	(revision 2797)
@@ -42,671 +44,505 @@
       !!                 ***  ROUTINE obc_init  ***
       !!         
-      !! ** Purpose :   Initialization of the dynamics and tracer fields at 
-      !!              the open boundaries.
+      !! ** Purpose :   Initialization of the dynamics and tracer fields with 
+      !!              unstructured open boundaries.
       !!
-      !! ** Method  :   initialization of open boundary variables
-      !!      (u, v) over 3 time step and 3 rows
-      !!      (t, s) over 2 time step and 2 rows
-      !!      if ln_rstart = .FALSE. : no restart, fields set to zero
-      !!      if ln_rstart = .TRUE.  : restart, fields are read in a file 
-      !!      if rdpxxx = 0 then lfbc is set true for this boundary.
+      !! ** Method  :   Read initialization arrays (mask, indices) to identify 
+      !!              an unstructured open boundary
       !!
-      !! ** Input   :   restart.obc file, restart file for open boundaries 
+      !! ** Input   :  obc_init.nc, input file for unstructured open boundaries
+      !!----------------------------------------------------------------------      
+      INTEGER  ::   ib_obc, ii, ij, ik, igrd, ib, ir   ! dummy loop indices
+      INTEGER  ::   icount, icountr, ibr_max, ilen1    ! local integers
+      INTEGER  ::   iw, ie, is, in, inum, id_dummy     !   -       -
+      INTEGER  ::   igrd_start, igrd_end, jpbdta       !   -       -
+      INTEGER, POINTER  ::  nbi, nbj, nbr              ! short cuts
+      REAL   , POINTER  ::  flagu, flagv               !    -   -
+      REAL(wp) ::   zefl, zwfl, znfl, zsfl             ! local scalars
+      INTEGER, DIMENSION (2)                ::   kdimsz
+      INTEGER, DIMENSION(jpbgrd,jp_obc)       ::   nblendta         ! Length of index arrays 
+      INTEGER, ALLOCATABLE, DIMENSION(:,:,:)  ::   nbidta, nbjdta   ! Index arrays: i and j indices of obc dta
+      INTEGER, ALLOCATABLE, DIMENSION(:,:,:)  ::   nbrdta           ! Discrete distance from rim points
+      REAL(wp), DIMENSION(jpidta,jpjdta)    ::   zmask            ! global domain mask
+      CHARACTER(LEN=80),DIMENSION(jpbgrd)  ::   clfile
+      CHARACTER(LEN=1),DIMENSION(jpbgrd)   ::   cgrid
+      !!
+      NAMELIST/namobc/ nb_obc, ln_coords_file, cn_coords_file,             &
+         &             ln_mask_file, cn_mask_file, nn_dyn2d, nn_dyn3d,     &
+         &             nn_tra,                                             &
+#if defined key_lim2
+         &             nn_ice_lim2,                                        &
+#endif
+         &             ln_tides, ln_vol, ln_clim, nn_dtactl, nn_volctl,    &
+         &             nn_rimwidth, nn_dmp2d_in, nn_dmp2d_out,             &
+         &             nn_dmp3d_in, nn_dmp3d_out
       !!----------------------------------------------------------------------
-      USE obcrst,   ONLY :   obc_rst_read   ! Make obc_rst_read routine available
-      !!
-      INTEGER  ::   ji, jj, istop , inumfbc
-      INTEGER, DIMENSION(4) ::   icorner
-      REAL(wp), DIMENSION(2) ::   ztestmask
-      !!
-      NAMELIST/namobc/ rn_dpein, rn_dpwin, rn_dpnin, rn_dpsin,       &
-         &             rn_dpeob, rn_dpwob, rn_dpnob, rn_dpsob,       &
-         &             rn_volemp, nn_obcdta, cn_obcdta,    &
-         &             ln_obc_clim, ln_vol_cst, ln_obc_fla
-      !!----------------------------------------------------------------------
-
-      REWIND( numnam )              ! Namelist namobc : open boundaries
-      READ  ( numnam, namobc )
-
-      ! convert DOCTOR namelist name into the OLD names
-      nobc_dta = nn_obcdta
-      cffile   = cn_obcdta
-      rdpein   = rn_dpein
-      rdpwin   = rn_dpwin
-      rdpsin   = rn_dpsin
-      rdpnin   = rn_dpnin
-      rdpeob   = rn_dpeob
-      rdpwob   = rn_dpwob
-      rdpsob   = rn_dpsob
-      rdpnob   = rn_dpnob
-      volemp   = rn_volemp
-
-      !                              ! allocate obc arrays
-      IF( obc_oce_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'obc_init : unable to allocate obc_oce arrays' )
-      IF( obc_dta_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'obc_init : unable to allocate obc_dta arrays' )
-
-      ! By security we set rdpxin and rdpxob respectively to 1. and 15. if the corresponding OBC is not activated
-      IF( .NOT.lp_obc_east  ) THEN   ;   rdpein = 1.   ;   rdpeob = 15.   ;   END IF
-      IF( .NOT.lp_obc_west  ) THEN   ;   rdpwin = 1.   ;   rdpwob = 15.   ;   END IF
-      IF( .NOT.lp_obc_north ) THEN   ;   rdpnin = 1.   ;   rdpnob = 15.   ;   END IF
-      IF( .NOT.lp_obc_south ) THEN   ;   rdpsin = 1.   ;   rdpsob = 15.   ;   END IF
-
-      ! number of open boudaries and open boundary indicators
-      nbobc = 0
-      IF( lp_obc_east  )   nbobc = nbobc + 1
-      IF( lp_obc_west  )   nbobc = nbobc + 1
-      IF( lp_obc_north )   nbobc = nbobc + 1
-      IF( lp_obc_south )   nbobc = nbobc + 1
+
+      IF( obc_oce_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'obc_init : unable to allocate oce arrays' )
 
       IF(lwp) WRITE(numout,*)
       IF(lwp) WRITE(numout,*) 'obc_init : initialization of open boundaries'
       IF(lwp) WRITE(numout,*) '~~~~~~~~'
-      IF(lwp) WRITE(numout,*) '   Number of open boundaries    nbobc = ', nbobc
-      IF(lwp) WRITE(numout,*)
-
-      ! control prints
-      IF(lwp) WRITE(numout,*) '   Namelist namobc'
-      IF(lwp) WRITE(numout,*) '      data in file (=1) or initial state used (=0)   nn_obcdta   = ', nn_obcdta
-      IF(lwp) WRITE(numout,*) '      climatology (true) or not                      ln_obc_clim = ', ln_obc_clim
-      IF(lwp) WRITE(numout,*) '      vol_cst (true) or not:                         ln_vol_cst  = ', ln_vol_cst
-      IF(lwp) WRITE(numout,*) ' '
-      IF(lwp) WRITE(numout,*) '   WARNING                                                  '
-      IF(lwp) WRITE(numout,*) '      Flather"s algorithm is applied with explicit free surface scheme                 '
-      IF(lwp) WRITE(numout,*) '      or with free surface time-splitting scheme                                       '
-      IF(lwp) WRITE(numout,*) '      Nor radiation neither relaxation is allowed with explicit free surface scheme:   '
-      IF(lwp) WRITE(numout,*) '      Radiation and/or relaxation is allowed with free surface time-splitting scheme '
-      IF(lwp) WRITE(numout,*) '      depending of the choice of rdpXin = rdpXob  = 0. for open boundaries             '
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) '      For the filtered free surface case,                                              '
-      IF(lwp) WRITE(numout,*) '      radiation, relaxation or presciption of data can be applied                      '
-      IF(lwp) WRITE(numout,*)
-
-      IF( lwp.AND.lp_obc_east ) THEN
-         WRITE(numout,*) '      East open boundary :'
-         WRITE(numout,*) '         i index                    jpieob   = ', jpieob
-         WRITE(numout,*) '         damping time scale (days)  rn_dpeob = ', rn_dpeob
-         WRITE(numout,*) '         damping time scale (days)  rn_dpein = ', rn_dpein
+      !
+
+      IF( jperio /= 0 )   CALL ctl_stop( 'Cyclic or symmetric,',   &
+         &                               ' and general open boundary condition are not compatible' )
+
+      cgrid= (/'T','U','V'/)
+
+      ! -----------------------------------------
+      ! Initialise and read namelist parameters
+      ! -----------------------------------------
+
+      nb_obc            = 0
+      ln_coords_file(:) = .false.
+      cn_coords_file(:) = ''
+      ln_mask_file      = .false.
+      cn_mask_file(:)   = ''
+      nn_dyn2d(:)       = 0
+      nn_dyn3d(:)       = 0
+      nn_tra(:)         = 0
+#if defined key_lim2
+      nn_ice_lim2(:)    = 0
+#endif
+      ln_tides(:)       = .false.
+      ln_vol            = .false.
+      ln_clim(:)        = .false.
+      nn_dtactl(:)      = -1  ! uninitialised flag
+      nn_volctl         = -1  ! uninitialised flag
+      nn_rimwidth(:)    = -1  ! uninitialised flag
+      nn_dmp2d_in(:)    = -1  ! uninitialised flag
+      nn_dmp2d_out(:)   = -1  ! uninitialised flag
+      nn_dmp3d_in(:)    = -1  ! uninitialised flag
+      nn_dmp3d_out(:)   = -1  ! uninitialised flag
+
+      REWIND( numnam )                    
+      READ  ( numnam, namobc )
+
+      ! -----------------------------------------
+      ! Check and write out namelist parameters
+      ! -----------------------------------------
+
+      !                                   ! control prints
+      IF(lwp) WRITE(numout,*) '         namobc'
+
+      IF( nb_obc .eq. 0 ) THEN 
+        IF(lwp) WRITE(numout,*) 'nb_obc = 0, NO OPEN BOUNDARIES APPLIED.'
+      ELSE
+        IF(lwp) WRITE(numout,*) 'Number of open boundary sets : ',nb_obc
       ENDIF
 
-      IF( lwp.AND.lp_obc_west ) THEN
-         WRITE(numout,*) '      West open boundary :'
-         WRITE(numout,*) '         i index                    jpiwob   = ', jpiwob
-         WRITE(numout,*) '         damping time scale (days)  rn_dpwob = ', rn_dpwob
-         WRITE(numout,*) '         damping time scale (days)  rn_dpwin = ', rn_dpwin
+      DO ib_obc = 1,nb_obc
+        IF(lwp) WRITE(numout,*) ' ' 
+        IF(lwp) WRITE(numout,*) '------ Open boundary data set ',ib_obc,'------' 
+
+        !                                         ! check type of data used (nn_dtactl value)
+        SELECT CASE( nn_dtactl(ib_obc) )                   ! 
+          CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      initial state used for obc data'        
+          CASE( 1 )      ;   IF(lwp) WRITE(numout,*) '      boundary data taken from file'
+          CASE DEFAULT   ;   CALL ctl_stop( 'nn_dtactl must be 0 or 1' )
+        END SELECT
+        IF(lwp) WRITE(numout,*)
+
+        IF(lwp) WRITE(numout,*) 'Boundary conditions for barotropic solution:  '
+        SELECT CASE( nn_dyn2d(ib_obc) )                  
+          CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      no open boundary condition'        
+          CASE( 1 )      ;   IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
+          CASE( 2 )      ;   IF(lwp) WRITE(numout,*) '      Flather radiation condition'
+          CASE DEFAULT   ;   CALL ctl_stop( 'unrecognised value for nn_dyn2d' )
+        END SELECT
+        IF(lwp) WRITE(numout,*)
+
+        IF(lwp) WRITE(numout,*) 'Boundary conditions for baroclinic velocities:  '
+        SELECT CASE( nn_dyn3d(ib_obc) )                  
+          CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      no open boundary condition'        
+          CASE( 1 )      ;   IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
+          CASE DEFAULT   ;   CALL ctl_stop( 'unrecognised value for nn_dyn3d' )
+        END SELECT
+        IF(lwp) WRITE(numout,*)
+
+        IF(lwp) WRITE(numout,*) 'Boundary conditions for temperature and salinity:  '
+        SELECT CASE( nn_tra(ib_obc) )                  
+          CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      no open boundary condition'        
+          CASE( 1 )      ;   IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
+          CASE DEFAULT   ;   CALL ctl_stop( 'unrecognised value for nn_tra' )
+        END SELECT
+        IF(lwp) WRITE(numout,*)
+
+#if defined key_lim2
+        IF(lwp) WRITE(numout,*) 'Boundary conditions for sea ice:  '
+        SELECT CASE( nn_tra(ib_obc) )                  
+          CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      no open boundary condition'        
+          CASE( 1 )      ;   IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
+          CASE DEFAULT   ;   CALL ctl_stop( 'unrecognised value for nn_tra' )
+        END SELECT
+        IF(lwp) WRITE(numout,*)
+#endif
+
+        IF(lwp) WRITE(numout,*) 'Boundary rim width for the FRS nn_rimwidth = ', nn_rimwidth
+        IF(lwp) WRITE(numout,*)
+
+        IF( ln_tides(ib_obc) ) THEN
+          IF(lwp) WRITE(numout,*) 'Tidal harmonic forcing at unstructured open boundaries'
+          IF(lwp) WRITE(numout,*)
+        ENDIF
+
+!!$        ! Presumably will need to read in a separate namelist for each boundary that includes tides???
+!!$        IF( ln_tides )   CALL tide_init( ib_obc )      ! Read tides namelist 
+
+
+      ENDDO
+
+     IF( ln_vol ) THEN                     ! check volume conservation (nn_volctl value)
+       IF(lwp) WRITE(numout,*) 'Volume correction applied at open boundaries'
+       IF(lwp) WRITE(numout,*)
+       SELECT CASE ( nn_volctl )
+         CASE( 1 )      ;   IF(lwp) WRITE(numout,*) '      The total volume will be constant'
+         CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      The total volume will vary according to the surface E-P flux'
+         CASE DEFAULT   ;   CALL ctl_stop( 'nn_volctl must be 0 or 1' )
+       END SELECT
+       IF(lwp) WRITE(numout,*)
+     ELSE
+       IF(lwp) WRITE(numout,*) 'No volume correction applied at open boundaries'
+       IF(lwp) WRITE(numout,*)
+     ENDIF
+
+      ! -------------------------------------------------
+      ! Initialise indices arrays for open boundaries
+      ! -------------------------------------------------
+
+      ! Work out global dimensions of boundary data
+      ! ---------------------------------------------
+      DO ib_obc = 1, nb_obc
+
+         jpbdta = 1
+         IF( .NOT. ln_coords_file(ib_obc) ) THEN ! Work out size of global arrays from namelist parameters
+ 
+
+           !! 1. Read parameters from namelist
+           !! 2. Work out global size of boundary data arrays nblendta and jpbdta
+
+
+         ELSE            ! Read size of arrays in boundary coordinates file.
+
+
+            CALL iom_open( cn_coords_file(ib_obc), inum )
+            jpbdta = 1
+            DO igrd = 1, jpbgrd
+               id_dummy = iom_varid( inum, 'nbi'//cgrid(igrd), kdimsz=kdimsz )  
+               nblendta(igrd,ib_obc) = kdimsz(1)
+               jpbdta = MAX(jpbdta, kdimsz(1))
+            ENDDO
+
+         ENDIF 
+
+      ENDDO
+
+      ! Allocate arrays
+      !---------------
+      ALLOCATE( nbidta(jpbdta, jpbgrd, nb_obc), nbjdta(jpbdta, jpbgrd, nb_obc),    &
+         &      nbrdta(jpbdta, jpbgrd, nb_obc) )
+
+      ALLOCATE( dta_global(jpbdta, 1, jpk) )
+
+      ! Calculate global boundary index arrays or read in from file
+      !------------------------------------------------------------
+      DO ib_obc = 1, nb_obc
+
+         IF( .NOT. ln_coords_file(ib_obc) ) THEN ! Calculate global index arrays from namelist parameters
+
+           !! Calculate global index arrays from namelist parameters
+
+         ELSE            ! Read global index arrays from boundary coordinates file.
+
+            DO igrd = 1, jpbgrd
+               CALL iom_get( inum, jpdom_unknown, 'nbi'//cgrid(igrd), dta_global(1:nblendta(igrd,ib_obc),:,1) )
+               DO ii = 1,nblendta(igrd,ib_obc)
+                  nbidta(ii,igrd,ib_obc) = INT( dta_global(ii,1,1) )
+               END DO
+               CALL iom_get( inum, jpdom_unknown, 'nbj'//cgrid(igrd), dta_global(1:nblendta(igrd,ib_obc),:,1) )
+               DO ii = 1,nblendta(igrd,ib_obc)
+                  nbjdta(ii,igrd,ib_obc) = INT( dta_global(ii,1,1) )
+               END DO
+               CALL iom_get( inum, jpdom_unknown, 'nbr'//cgrid(igrd), dta_global(1:nblendta(igrd,ib_obc),:,1) )
+               DO ii = 1,nblendta(igrd,ib_obc)
+                  nbrdta(ii,igrd,ib_obc) = INT( dta_global(ii,1,1) )
+               END DO
+
+               ibr_max = MAXVAL( nbrdta(:,igrd,ib_obc) )
+               IF(lwp) WRITE(numout,*)
+               IF(lwp) WRITE(numout,*) ' Maximum rimwidth in file is ', ibr_max
+               IF(lwp) WRITE(numout,*) ' nn_rimwidth from namelist is ', nn_rimwidth(ib_obc)
+               IF (ibr_max < nn_rimwidth(ib_obc))   &
+                     CALL ctl_stop( 'nn_rimwidth is larger than maximum rimwidth in file',cn_coords_file(ib_obc) )
+
+            END DO
+            CALL iom_close( inum )
+
+         ENDIF 
+
+      ENDDO 
+
+      ! Work out dimensions of boundary data on each processor
+      ! ------------------------------------------------------
+     
+      iw = mig(1) + 1            ! if monotasking and no zoom, iw=2
+      ie = mig(1) + nlci-1 - 1   ! if monotasking and no zoom, ie=jpim1
+      is = mjg(1) + 1            ! if monotasking and no zoom, is=2
+      in = mjg(1) + nlcj-1 - 1   ! if monotasking and no zoom, in=jpjm1
+
+      DO ib_obc = 1, nb_obc
+         DO igrd = 1, jpbgrd
+            icount  = 0
+            icountr = 0
+            idx_obc(ib_obc)%nblen(igrd)    = 0
+            idx_obc(ib_obc)%nblenrim(igrd) = 0
+            DO ib = 1, nblendta(igrd,ib_obc)
+               ! check if point is in local domain
+               IF(  nbidta(ib,igrd,ib_obc) >= iw .AND. nbidta(ib,igrd,ib_obc) <= ie .AND.   &
+                  & nbjdta(ib,igrd,ib_obc) >= is .AND. nbjdta(ib,igrd,ib_obc) <= in       ) THEN
+                  !
+                  icount = icount  + 1
+                  !
+                  IF( nbrdta(ib,igrd,ib_obc) == 1 )   icountr = icountr+1
+               ENDIF
+            ENDDO
+            idx_obc(ib_obc)%nblenrim(igrd) = icountr !: length of rim boundary data on each proc
+            idx_obc(ib_obc)%nblen   (igrd) = icount  !: length of boundary data on each proc        
+         ENDDO  ! igrd
+
+         ! Allocate index arrays for this boundary set
+         !--------------------------------------------
+         ilen1 = MAXVAL(idx_obc(ib_obc)%nblen(:))
+         ALLOCATE( idx_obc(ib_obc)%nbi(ilen1,jpbgrd) )
+         ALLOCATE( idx_obc(ib_obc)%nbj(ilen1,jpbgrd) )
+         ALLOCATE( idx_obc(ib_obc)%nbr(ilen1,jpbgrd) )
+         ALLOCATE( idx_obc(ib_obc)%nbmap(ilen1,jpbgrd) )
+         ALLOCATE( idx_obc(ib_obc)%nbw(ilen1,jpbgrd) )
+         ALLOCATE( idx_obc(ib_obc)%flagu(ilen1) )
+         ALLOCATE( idx_obc(ib_obc)%flagv(ilen1) )
+
+         ! Dispatch mapping indices and discrete distances on each processor
+         ! -----------------------------------------------------------------
+
+         DO igrd = 1, jpbgrd
+            icount  = 0
+            ! Loop on rimwidth to ensure outermost points come first in the local arrays.
+            DO ir=1, nn_rimwidth(ib_obc)
+               DO ib = 1, nblendta(igrd,ib_obc)
+                  ! check if point is in local domain and equals ir
+                  IF(  nbidta(ib,igrd,ib_obc) >= iw .AND. nbidta(ib,igrd,ib_obc) <= ie .AND.   &
+                     & nbjdta(ib,igrd,ib_obc) >= is .AND. nbjdta(ib,igrd,ib_obc) <= in .AND.   &
+                     & nbrdta(ib,igrd,ib_obc) == ir  ) THEN
+                     !
+                     icount = icount  + 1
+                     idx_obc(ib_obc)%nbi(icount,igrd)   = nbidta(ib,igrd,ib_obc)- mig(1)+1
+                     idx_obc(ib_obc)%nbj(icount,igrd)   = nbjdta(ib,igrd,ib_obc)- mjg(1)+1
+                     idx_obc(ib_obc)%nbr(icount,igrd)   = nbrdta(ib,igrd,ib_obc)
+                     idx_obc(ib_obc)%nbmap(icount,igrd) = ib
+                  ENDIF
+               ENDDO
+            ENDDO
+         ENDDO 
+
+         ! Compute rim weights
+         ! -------------------
+         DO igrd = 1, jpbgrd
+            DO ib = 1, idx_obc(ib_obc)%nblen(igrd)
+               nbr => idx_obc(ib_obc)%nbr(ib,igrd)
+               idx_obc(ib_obc)%nbw(ib,igrd) = 1.- TANH( FLOAT( nbr - 1 ) *0.5 )      ! tanh formulation
+!              idx_obc(ib_obc)%nbw(ib,igrd) = (FLOAT(nn_rimwidth+1-nbr)/FLOAT(nn_rimwidth))**2      ! quadratic
+!              idx_obc(ib_obc)%nbw(ib,igrd) =  FLOAT(nn_rimwidth+1-nbr)/FLOAT(nn_rimwidth)          ! linear
+            END DO
+         END DO 
+
+      ENDDO
+
+      ! ------------------------------------------------------
+      ! Initialise masks and find normal/tangential directions
+      ! ------------------------------------------------------
+
+      ! Read global 2D mask at T-points: obctmask
+      ! -----------------------------------------
+      ! obctmask = 1  on the computational domain AND on open boundaries
+      !          = 0  elsewhere   
+ 
+      IF( cp_cfg == "eel" .AND. jp_cfg == 5 ) THEN          ! EEL configuration at 5km resolution
+         zmask(         :                ,:) = 0.e0
+         zmask(jpizoom+1:jpizoom+jpiglo-2,:) = 1.e0          
+      ELSE IF( ln_mask_file ) THEN
+         CALL iom_open( cn_mask_file, inum )
+         CALL iom_get ( inum, jpdom_data, 'obc_msk', zmask(:,:) )
+         CALL iom_close( inum )
+      ELSE
+         zmask(:,:) = 1.e0
       ENDIF
 
-      IF( lwp.AND.lp_obc_north ) THEN
-         WRITE(numout,*) '      North open boundary :'
-         WRITE(numout,*) '         j index                    jpjnob   = ', jpjnob
-         WRITE(numout,*) '         damping time scale (days)  rn_dpnob = ', rn_dpnob
-         WRITE(numout,*) '         damping time scale (days)  rn_dpnin = ', rn_dpnin
-      ENDIF
-
-      IF( lwp.AND.lp_obc_south ) THEN
-         WRITE(numout,*) '      South open boundary :'
-         WRITE(numout,*) '         j index                    jpjsob   = ', jpjsob
-         WRITE(numout,*) '         damping time scale (days)  rn_dpsob = ', rn_dpsob
-         WRITE(numout,*) '         damping time scale (days)  rn_dpsin = ', rn_dpsin
-         WRITE(numout,*)
-      ENDIF
-
-      IF( nbobc >= 2 .AND. jperio /= 0 )   &
-         &   CALL ctl_stop( ' Cyclic or symmetric, and open boundary condition are not compatible' )
-
-      ! 1. Initialisation of constants 
-      ! ------------------------------
-      ! ...                          convert rdp$ob in seconds
-      ! Fixed Bdy flag              inbound                outbound
-      lfbceast  = .FALSE.   ;   rdpein = rdpein * rday    ;   rdpeob = rdpeob * rday
-      lfbcwest  = .FALSE.   ;   rdpwin = rdpwin * rday    ;   rdpwob = rdpwob * rday
-      lfbcnorth = .FALSE.   ;   rdpnin = rdpnin * rday    ;   rdpnob = rdpnob * rday
-      lfbcsouth = .FALSE.   ;   rdpsin = rdpsin * rday    ;   rdpsob = rdpsob * rday
-      inumfbc = 0
-      ! ... look for Fixed Boundaries (rdp = 0 )
-      ! ... When specified, lbcxxx flags are set to TRUE and rdpxxx are set to
-      ! ...  a small arbitrary value, (to avoid division by zero further on). 
-      ! ...  rdpxxx is not used anymore.
-      IF( lp_obc_east )  THEN
-         IF( (rdpein+rdpeob) == 0 )  THEN
-            lfbceast = .TRUE.   ;   rdpein = 1e-3   ;   rdpeob = 1e-3
-            inumfbc = inumfbc+1
-         ELSEIF ( (rdpein*rdpeob) == 0 )  THEN
-            CALL ctl_stop( 'obc_init : rn_dpein & rn_dpeob must be both zero or non zero' )
-         END IF
-      END IF
-
-      IF( lp_obc_west )  THEN
-         IF( (rdpwin + rdpwob) == 0 )  THEN
-            lfbcwest = .TRUE.     ;     rdpwin = 1e-3     ;     rdpwob = 1e-3
-            inumfbc = inumfbc+1
-         ELSEIF ( (rdpwin*rdpwob) == 0 )  THEN
-            CALL ctl_stop( 'obc_init : rn_dpwin & rn_dpwob must be both zero or non zero' )
-         END IF
-      END IF
-      IF( lp_obc_north )  THEN
-         IF( (rdpnin + rdpnob) == 0 )  THEN
-            lfbcnorth = .TRUE.     ;     rdpnin = 1e-3     ;     rdpnob = 1e-3
-            inumfbc = inumfbc+1
-         ELSEIF ( (rdpnin*rdpnob) == 0 )  THEN
-            CALL ctl_stop( 'obc_init : rn_dpnin & rn_dpnob must be both zero or non zero' )
-         END IF
-      END IF
-      IF( lp_obc_south )  THEN
-         IF( (rdpsin + rdpsob) == 0 )  THEN
-            lfbcsouth = .TRUE.   ;   rdpsin = 1e-3   ;   rdpsob = 1e-3
-            inumfbc = inumfbc+1
-         ELSEIF ( (rdpsin*rdpsob) == 0 )  THEN
-            CALL ctl_stop( 'obc_init : rn_dpsin & rn_dpsob must be both zero or non zero' )
-         END IF
-      END IF
-
-      ! 2.  Clever mpp indices for loops on the open boundaries. 
-      !     The loops will be performed only on the processors 
-      !     that contain a given open boundary.
-      ! --------------------------------------------------------
-
-      IF( lp_obc_east ) THEN
-         ! ...   mpp initialization
-         nie0   = max( 1, min(jpieob   - nimpp+1, jpi     ) )
-         nie1   = max( 0, min(jpieob   - nimpp+1, jpi - 1 ) )
-         nie0p1 = max( 1, min(jpieob+1 - nimpp+1, jpi     ) )
-         nie1p1 = max( 0, min(jpieob+1 - nimpp+1, jpi - 1 ) )
-         nie0m1 = max( 1, min(jpieob-1 - nimpp+1, jpi     ) )
-         nie1m1 = max( 0, min(jpieob-1 - nimpp+1, jpi - 1 ) )
-         nje0   = max( 2, min(jpjed    - njmpp+1, jpj     ) )
-         nje1   = max( 0, min(jpjef    - njmpp+1, jpj - 1 ) )
-         nje0p1 = max( 1, min(jpjedp1  - njmpp+1, jpj     ) )
-         nje0m1 = max( 1, min(jpjed    - njmpp+1, jpj     ) )
-         nje1m1 = max( 0, min(jpjefm1  - njmpp+1, jpj - 1 ) )
-         nje1m2 = max( 0, min(jpjefm1-1- njmpp+1, jpj - 1 ) )
-         IF(lwp) THEN
-            IF( lfbceast ) THEN
-               WRITE(numout,*)'     '
-               WRITE(numout,*)'         Specified East Open Boundary'
+      DO ij = 1, nlcj      ! Save mask over local domain      
+         DO ii = 1, nlci
+            obctmask(ii,ij) = zmask( mig(ii), mjg(ij) )
+         END DO
+      END DO
+
+      ! Derive mask on U and V grid from mask on T grid
+      obcumask(:,:) = 0.e0
+      obcvmask(:,:) = 0.e0
+      DO ij=1, jpjm1
+         DO ii=1, jpim1
+            obcumask(ii,ij)=obctmask(ii,ij)*obctmask(ii+1, ij )
+            obcvmask(ii,ij)=obctmask(ii,ij)*obctmask(ii  ,ij+1)  
+         END DO
+      END DO
+      CALL lbc_lnk( obcumask(:,:), 'U', 1. )   ;   CALL lbc_lnk( obcvmask(:,:), 'V', 1. )      ! Lateral boundary cond.
+
+
+      ! Mask corrections
+      ! ----------------
+      DO ik = 1, jpkm1
+         DO ij = 1, jpj
+            DO ii = 1, jpi
+               tmask(ii,ij,ik) = tmask(ii,ij,ik) * obctmask(ii,ij)
+               umask(ii,ij,ik) = umask(ii,ij,ik) * obcumask(ii,ij)
+               vmask(ii,ij,ik) = vmask(ii,ij,ik) * obcvmask(ii,ij)
+               bmask(ii,ij)    = bmask(ii,ij)    * obctmask(ii,ij)
+            END DO      
+         END DO
+      END DO
+
+      DO ik = 1, jpkm1
+         DO ij = 2, jpjm1
+            DO ii = 2, jpim1
+               fmask(ii,ij,ik) = fmask(ii,ij,ik) * obctmask(ii,ij  ) * obctmask(ii+1,ij  )   &
+                  &                              * obctmask(ii,ij+1) * obctmask(ii+1,ij+1)
+            END DO      
+         END DO
+      END DO
+
+      tmask_i (:,:) = tmask(:,:,1) * tmask_i(:,:)             
+      obctmask(:,:) = tmask(:,:,1)
+
+      ! obc masks and bmask are now set to zero on boundary points:
+      igrd = 1       ! In the free surface case, bmask is at T-points
+      DO ib_obc = 1, nb_obc
+        DO ib = 1, idx_obc(ib_obc)%nblenrim(igrd)     
+          bmask(idx_obc(ib_obc)%nbi(ib,igrd), idx_obc(ib_obc)%nbj(ib,igrd)) = 0.e0
+        ENDDO
+      ENDDO
+      !
+      igrd = 1
+      DO ib_obc = 1, nb_obc
+        DO ib = 1, idx_obc(ib_obc)%nblenrim(igrd)      
+          obctmask(idx_obc(ib_obc)%nbi(ib,igrd), idx_obc(ib_obc)%nbj(ib,igrd)) = 0.e0
+        ENDDO
+      ENDDO
+      !
+      igrd = 2
+      DO ib_obc = 1, nb_obc
+        DO ib = 1, idx_obc(ib_obc)%nblenrim(igrd)
+          obcumask(idx_obc(ib_obc)%nbi(ib,igrd), idx_obc(ib_obc)%nbj(ib,igrd)) = 0.e0
+        ENDDO
+      ENDDO
+      !
+      igrd = 3
+      DO ib_obc = 1, nb_obc
+        DO ib = 1, idx_obc(ib_obc)%nblenrim(igrd)
+          obcvmask(idx_obc(ib_obc)%nbi(ib,igrd), idx_obc(ib_obc)%nbj(ib,igrd)) = 0.e0
+        ENDDO
+      ENDDO
+
+      ! Lateral boundary conditions
+      CALL lbc_lnk( fmask        , 'F', 1. )   ;   CALL lbc_lnk( obctmask(:,:), 'T', 1. )
+      CALL lbc_lnk( obcumask(:,:), 'U', 1. )   ;   CALL lbc_lnk( obcvmask(:,:), 'V', 1. )
+
+      DO ib_obc = 1, nb_obc       ! Indices and directions of rim velocity components
+
+         idx_obc(ib_obc)%flagu(:) = 0.e0
+         idx_obc(ib_obc)%flagv(:) = 0.e0
+         icount = 0 
+
+         !flagu = -1 : u component is normal to the dynamical boundary but its direction is outward
+         !flagu =  0 : u is tangential
+         !flagu =  1 : u is normal to the boundary and is direction is inward
+  
+         igrd = 2      ! u-component 
+         DO ib = 1, idx_obc(ib_obc)%nblenrim(igrd)  
+            nbi => idx_obc(ib_obc)%nbi(ib,igrd)
+            nbj => idx_obc(ib_obc)%nbj(ib,igrd)
+            zefl = obctmask(nbi  ,nbj)
+            zwfl = obctmask(nbi+1,nbj)
+            IF( zefl + zwfl == 2 ) THEN
+               icount = icount + 1
             ELSE
-               WRITE(numout,*)'     '
-               WRITE(numout,*)'         Radiative East Open Boundary'
+               idx_obc(ib_obc)%flagu(ib)=-zefl+zwfl
+            ENDIF
+         END DO
+
+         !flagv = -1 : u component is normal to the dynamical boundary but its direction is outward
+         !flagv =  0 : u is tangential
+         !flagv =  1 : u is normal to the boundary and is direction is inward
+
+         igrd = 3      ! v-component
+         DO ib = 1, idx_obc(ib_obc)%nblenrim(igrd)  
+            nbi => idx_obc(ib_obc)%nbi(ib,igrd)
+            nbj => idx_obc(ib_obc)%nbj(ib,igrd)
+            znfl = obctmask(nbi,nbj  )
+            zsfl = obctmask(nbi,nbj+1)
+            IF( znfl + zsfl == 2 ) THEN
+               icount = icount + 1
+            ELSE
+               idx_obc(ib_obc)%flagv(ib) = -znfl + zsfl
             END IF
-         END IF
-      END IF
-
-      IF( lp_obc_west ) THEN
-         ! ...   mpp initialization
-         niw0   = max( 1, min(jpiwob   - nimpp+1, jpi     ) )
-         niw1   = max( 0, min(jpiwob   - nimpp+1, jpi - 1 ) )
-         niw0p1 = max( 1, min(jpiwob+1 - nimpp+1, jpi     ) )
-         niw1p1 = max( 0, min(jpiwob+1 - nimpp+1, jpi - 1 ) )
-         njw0   = max( 2, min(jpjwd    - njmpp+1, jpj     ) )
-         njw1   = max( 0, min(jpjwf    - njmpp+1, jpj - 1 ) )
-         njw0p1 = max( 1, min(jpjwdp1  - njmpp+1, jpj     ) )
-         njw0m1 = max( 1, min(jpjwd    - njmpp+1, jpj     ) )
-         njw1m1 = max( 0, min(jpjwfm1  - njmpp+1, jpj - 1 ) )
-         njw1m2 = max( 0, min(jpjwfm1-1- njmpp+1, jpj - 1 ) )
-         IF(lwp) THEN
-            IF( lfbcwest ) THEN
-               WRITE(numout,*)'     '
-               WRITE(numout,*)'         Specified West Open Boundary'
-            ELSE
-               WRITE(numout,*)'     '
-               WRITE(numout,*)'         Radiative West Open Boundary'
-            END IF
-         END IF
-      END IF
+         END DO
  
-      IF( lp_obc_north ) THEN
-         ! ...   mpp initialization
-         nin0   = max( 2, min(jpind    - nimpp+1, jpi     ) )
-         nin1   = max( 0, min(jpinf    - nimpp+1, jpi - 1 ) )
-         nin0p1 = max( 1, min(jpindp1  - nimpp+1, jpi     ) )
-         nin0m1 = max( 1, min(jpind    - nimpp+1, jpi     ) )
-         nin1m1 = max( 0, min(jpinfm1  - nimpp+1, jpi - 1 ) )
-         nin1m2 = max( 0, min(jpinfm1-1- nimpp+1, jpi - 1 ) )
-         njn0   = max( 1, min(jpjnob   - njmpp+1, jpj     ) )
-         njn1   = max( 0, min(jpjnob   - njmpp+1, jpj - 1 ) )
-         njn0p1 = max( 1, min(jpjnob+1 - njmpp+1, jpj     ) )
-         njn1p1 = max( 0, min(jpjnob+1 - njmpp+1, jpj - 1 ) )
-         njn0m1 = max( 1, min(jpjnob-1 - njmpp+1, jpj     ) )
-         njn1m1 = max( 0, min(jpjnob-1 - njmpp+1, jpj - 1 ) )
-         IF(lwp) THEN
-            IF( lfbcnorth ) THEN
-               WRITE(numout,*)'     '
-               WRITE(numout,*)'         Specified North Open Boundary'
-            ELSE
-               WRITE(numout,*)'     '
-               WRITE(numout,*)'         Radiative North Open Boundary'
-            END IF
-         END IF
-      END IF
-
-      IF( lp_obc_south ) THEN
-         ! ...   mpp initialization
-         nis0   = max( 2, min(jpisd    - nimpp+1, jpi     ) )
-         nis1   = max( 0, min(jpisf    - nimpp+1, jpi - 1 ) )
-         nis0p1 = max( 1, min(jpisdp1  - nimpp+1, jpi     ) )
-         nis0m1 = max( 1, min(jpisd    - nimpp+1, jpi     ) )
-         nis1m1 = max( 0, min(jpisfm1  - nimpp+1, jpi - 1 ) )
-         nis1m2 = max( 0, min(jpisfm1-1- nimpp+1, jpi - 1 ) )
-         njs0   = max( 1, min(jpjsob   - njmpp+1, jpj     ) )
-         njs1   = max( 0, min(jpjsob   - njmpp+1, jpj - 1 ) )
-         njs0p1 = max( 1, min(jpjsob+1 - njmpp+1, jpj     ) )
-         njs1p1 = max( 0, min(jpjsob+1 - njmpp+1, jpj - 1 ) )
-         IF(lwp) THEN
-            IF( lfbcsouth ) THEN
-               WRITE(numout,*)'     '
-               WRITE(numout,*)'         Specified South Open Boundary'
-            ELSE
-               WRITE(numout,*)'     '
-               WRITE(numout,*)'         Radiative South Open Boundary'
-            END IF
-         END IF
-      END IF
-
-      ! 3. mask correction for OBCs
-      ! ---------------------------
-
-      IF( lp_obc_east ) THEN
-         !... (jpjed,jpjefm1),jpieob
-         bmask(nie0p1:nie1p1,nje0:nje1m1) = 0.e0
-
-         ! ... initilization to zero
-         uemsk(:,:) = 0.e0   ;   vemsk(:,:) = 0.e0   ;   temsk(:,:) = 0.e0
-
-         ! ... set 2D mask on East OBC,  Vopt
-         DO ji = fs_nie0, fs_nie1
-            DO jj = nje0, nje1
-               uemsk(jj,:) = umask(ji,  jj,:) * tmask_i(ji,jj)   * tmask_i(ji+1,jj)
-               vemsk(jj,:) = vmask(ji+1,jj,:) * tmask_i(ji+1,jj) 
-               temsk(jj,:) = tmask(ji+1,jj,:) * tmask_i(ji+1,jj) 
-            END DO
-         END DO
-
-      END IF
-
-      IF( lp_obc_west ) THEN
-         ! ... (jpjwd,jpjwfm1),jpiwob
-         bmask(niw0:niw1,njw0:njw1m1) = 0.e0
-
-         ! ... initilization to zero
-         uwmsk(:,:) = 0.e0   ;   vwmsk(:,:) = 0.e0   ;   twmsk(:,:) = 0.e0  
-
-         ! ... set 2D mask on West OBC,  Vopt
-         DO ji = fs_niw0, fs_niw1
-            DO jj = njw0, njw1
-               uwmsk(jj,:) = umask(ji,jj,:) * tmask_i(ji,jj)   * tmask_i(ji+1,jj)
-               vwmsk(jj,:) = vmask(ji,jj,:) * tmask_i(ji,jj)  
-               twmsk(jj,:) = tmask(ji,jj,:) * tmask_i(ji,jj)
-            END DO
-         END DO
-
-      END IF
-
-      IF( lp_obc_north ) THEN
-         ! ... jpjnob,(jpind,jpisfm1)
-         bmask(nin0:nin1m1,njn0p1:njn1p1) = 0.e0
-
-         ! ... initilization to zero
-         unmsk(:,:) = 0.e0   ;   vnmsk(:,:) = 0.e0   ;   tnmsk(:,:) = 0.e0
-
-         ! ... set 2D mask on North OBC,  Vopt
-         DO jj = fs_njn0, fs_njn1
-            DO ji = nin0, nin1
-               unmsk(ji,:) = umask(ji,jj+1,:) * tmask_i(ji,jj+1) 
-               vnmsk(ji,:) = vmask(ji,jj  ,:) * tmask_i(ji,jj)   * tmask_i(ji,jj+1)
-               tnmsk(ji,:) = tmask(ji,jj+1,:) * tmask_i(ji,jj+1)
-            END DO
-         END DO
-
-      END IF
-
-      IF( lp_obc_south ) THEN 
-         ! ... jpjsob,(jpisd,jpisfm1)
-         bmask(nis0:nis1m1,njs0:njs1) = 0.e0
-
-         ! ... initilization to zero
-         usmsk(:,:) = 0.e0   ;   vsmsk(:,:) = 0.e0   ;   tsmsk(:,:) = 0.e0
-
-         ! ... set 2D mask on South OBC,  Vopt
-         DO jj = fs_njs0, fs_njs1 
-            DO ji = nis0, nis1
-               usmsk(ji,:) = umask(ji,jj,:) * tmask_i(ji,jj) 
-               vsmsk(ji,:) = vmask(ji,jj,:) * tmask_i(ji,jj) * tmask_i(ji,jj+1)
-               tsmsk(ji,:) = tmask(ji,jj,:) * tmask_i(ji,jj)
-            END DO
-         END DO
-
-      END IF
-
-      ! ... Initialize obcumask and obcvmask for the Force filtering 
-      !     boundary condition in dynspg_flt
-      obcumask(:,:) = umask(:,:,1)
-      obcvmask(:,:) = vmask(:,:,1)
-
-      ! ... Initialize obctmsk on overlap region and obcs. This mask
-      !     is used in obcvol.F90 to calculate cumulate flux E-P. 
-      !     obc Tracer point are outside the domain ( U/V obc points) ==> masked by obctmsk
-      !     - no flux E-P on obcs and overlap region (jpreci = jprecj = 1)
-      obctmsk(:,:) = tmask_i(:,:)     
-
-      IF( lp_obc_east ) THEN
-         ! ... East obc Force filtering mask for the grad D
-         obcumask(nie0  :nie1  ,nje0p1:nje1m1) = 0.e0
-         obcvmask(nie0p1:nie1p1,nje0p1:nje1m1) = 0.e0
-         ! ... set to 0 on East OBC
-         obctmsk(nie0p1:nie1p1,nje0:nje1) = 0.e0
-      END IF
-
-      IF( lp_obc_west ) THEN
-         ! ... West obc Force filtering mask for the grad D
-         obcumask(niw0:niw1,njw0:njw1) = 0.e0
-         obcvmask(niw0:niw1,njw0:njw1) = 0.e0
-         ! ... set to 0 on West OBC
-         obctmsk(niw0:niw1,njw0:njw1) = 0.e0
-      END IF
-
-      IF( lp_obc_north ) THEN
-         ! ... North obc Force filtering mask for the grad D
-         obcumask(nin0p1:nin1m1,njn0p1:njn1p1) = 0.e0
-         obcvmask(nin0p1:nin1m1,njn0  :njn1  ) = 0.e0
-         ! ... set to 0 on North OBC
-         obctmsk(nin0:nin1,njn0p1:njn1p1) = 0.e0
-      END IF
-
-      IF( lp_obc_south ) THEN
-         ! ... South obc Force filtering mask for the grad D
-         obcumask(nis0p1:nis1m1,njs0:njs1) = 0.e0
-         obcvmask(nis0p1:nis1m1,njs0:njs1) = 0.e0
-         ! ... set to 0 on South OBC
-         obctmsk(nis0:nis1,njs0:njs1) = 0.e0
-      END IF
-
-      ! 3.1 Total lateral surface 
-      ! -------------------------
-      obcsurftot = 0.e0
-
-      IF( lp_obc_east ) THEN ! ... East open boundary lateral surface
-         DO ji = nie0, nie1
-            DO jj = 1, jpj 
-               obcsurftot = obcsurftot+hu(ji,jj)*e2u(ji,jj)*uemsk(jj,1) * MAX(obctmsk(ji,jj),obctmsk(ji+1,jj) )
-            END DO
-         END DO
-      END IF
-
-      IF( lp_obc_west ) THEN ! ... West open boundary lateral surface
-         DO ji = niw0, niw1
-            DO jj = 1, jpj 
-               obcsurftot = obcsurftot+hu(ji,jj)*e2u(ji,jj)*uwmsk(jj,1) * MAX(obctmsk(ji,jj),obctmsk(ji+1,jj) )
-            END DO
-         END DO
-      END IF
-
-      IF( lp_obc_north ) THEN ! ... North open boundary lateral surface
-         DO jj = njn0, njn1
-            DO ji = 1, jpi
-               obcsurftot = obcsurftot+hv(ji,jj)*e1v(ji,jj)*vnmsk(ji,1) * MAX(obctmsk(ji,jj),obctmsk(ji,jj+1) )
-            END DO
-         END DO
-      END IF
-
-      IF( lp_obc_south ) THEN ! ... South open boundary lateral surface
-         DO jj = njs0, njs1
-            DO ji = 1, jpi
-               obcsurftot = obcsurftot+hv(ji,jj)*e1v(ji,jj)*vsmsk(ji,1) * MAX(obctmsk(ji,jj),obctmsk(ji,jj+1) )
-            END DO
-         END DO
-      END IF
-
-      IF( lk_mpp )   CALL mpp_sum( obcsurftot )   ! sum over the global domain
-
-      ! 5. Control print on mask 
-      !    The extremities of the open boundaries must be in land
-      !    or else correspond to an "ocean corner" between two open boundaries. 
-      !    corner 1 is southwest, 2 is south east, 3 is northeast, 4 is northwest. 
-      ! --------------------------------------------------------------------------
-
-      icorner(:)=0
-
-      ! ... control of the west boundary
-      IF( lp_obc_west ) THEN
-         IF( jpiwob < 2 .OR.  jpiwob >= jpiglo-2 ) THEN
-            WRITE(ctmp1,*) ' jpiwob exceed ', jpiglo-2, 'or less than 2'
-            CALL ctl_stop( ctmp1 )
-         END IF
-         ztestmask(:)=0.
-         DO ji=niw0,niw1
-            IF( (njw0 + njmpp - 1) == jpjwd ) ztestmask(1)=ztestmask(1)+ tmask(ji,njw0,1)
-            IF( (njw1 + njmpp - 1) == jpjwf ) ztestmask(2)=ztestmask(2)+ tmask(ji,njw1,1)
-         END DO
-         IF( lk_mpp )   CALL mpp_sum( ztestmask, 2 )   ! sum over the global domain
-
-         IF( ztestmask(1) /= 0. ) icorner(1)=icorner(1)+1
-         IF( ztestmask(2) /= 0. ) icorner(4)=icorner(4)+1
-      END IF
-
-      ! ... control of the east boundary
-      IF( lp_obc_east ) THEN
-         IF( jpieob < 4 .OR.  jpieob >= jpiglo ) THEN
-            WRITE(ctmp1,*) ' jpieob exceed ', jpiglo, ' or less than 4'
-            CALL ctl_stop( ctmp1 )
-         END IF
-         ztestmask(:)=0.
-         DO ji=nie0p1,nie1p1
-            IF( (nje0 + njmpp - 1) == jpjed ) ztestmask(1)=ztestmask(1)+ tmask(ji,nje0,1)
-            IF( (nje1 + njmpp - 1) == jpjef ) ztestmask(2)=ztestmask(2)+ tmask(ji,nje1,1)
-         END DO
-         IF( lk_mpp )   CALL mpp_sum( ztestmask, 2 )   ! sum over the global domain
-
-        IF( ztestmask(1) /= 0. ) icorner(2)=icorner(2)+1
-        IF( ztestmask(2) /= 0. ) icorner(3)=icorner(3)+1
-      END IF
-
-      ! ... control of the north boundary
-      IF( lp_obc_north ) THEN
-         IF( jpjnob < 4 .OR.  jpjnob >= jpjglo ) THEN
-            WRITE(ctmp1,*) 'jpjnob exceed ', jpjglo, ' or less than 4'
-            CALL ctl_stop( ctmp1 )
-         END IF
-         ztestmask(:)=0.
-         DO jj=njn0p1,njn1p1
-            IF( (nin0 + nimpp - 1) == jpind ) ztestmask(1)=ztestmask(1)+ tmask(nin0,jj,1)
-            IF( (nin1 + nimpp - 1) == jpinf ) ztestmask(2)=ztestmask(2)+ tmask(nin1,jj,1)
-         END DO
-         IF( lk_mpp )   CALL mpp_sum( ztestmask, 2 )   ! sum over the global domain
-
-         IF( ztestmask(1) /= 0. ) icorner(4)=icorner(4)+1
-         IF( ztestmask(2) /= 0. ) icorner(3)=icorner(3)+1
-      END IF
-
-      ! ... control of the south boundary
-      IF( lp_obc_south ) THEN
-         IF( jpjsob < 2 .OR.  jpjsob >= jpjglo-2 ) THEN
-            WRITE(ctmp1,*) ' jpjsob exceed ', jpjglo-2, ' or less than 2'
-            CALL ctl_stop( ctmp1 )
-         END IF
-         ztestmask(:)=0.
-         DO jj=njs0,njs1
-            IF( (nis0 + nimpp - 1) == jpisd ) ztestmask(1)=ztestmask(1)+ tmask(nis0,jj,1)
-            IF( (nis1 + nimpp - 1) == jpisf ) ztestmask(2)=ztestmask(2)+ tmask(nis1,jj,1)
-         END DO
-         IF( lk_mpp )   CALL mpp_sum( ztestmask, 2 )   ! sum over the global domain
-
-         IF( ztestmask(1) /= 0. ) icorner(1)=icorner(1)+1
-         IF( ztestmask(2) /= 0. ) icorner(2)=icorner(2)+1
-      END IF
-
-      IF( icorner(1) == 2 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) ' South West ocean corner, two open boudaries'
-         IF(lwp) WRITE(numout,*) ' ========== '
-         IF(lwp) WRITE(numout,*)
-         IF( jpisd /= jpiwob.OR.jpjsob /= jpjwd ) &
-              &   CALL ctl_stop( ' Open boundaries do not fit, we stop' )
-
-      ELSE IF( icorner(1) == 1 ) THEN
-         CALL ctl_stop( ' Open boundaries do not fit at SW corner, we stop' )
-      END IF 
-
-      IF( icorner(2) == 2 ) THEN
-          IF(lwp) WRITE(numout,*)
-          IF(lwp) WRITE(numout,*) ' South East ocean corner, two open boudaries'
-          IF(lwp) WRITE(numout,*) ' ========== '
-          IF(lwp) WRITE(numout,*)
-          IF( jpisf /= jpieob+1.OR.jpjsob /= jpjed ) &
-               &   CALL ctl_stop( ' Open boundaries do not fit, we stop' )
-      ELSE IF( icorner(2) == 1 ) THEN
-         CALL ctl_stop( ' Open boundaries do not fit at SE corner, we stop' )
-      END IF 
-
-      IF( icorner(3) == 2 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) ' North East ocean corner, two open boudaries'
-         IF(lwp) WRITE(numout,*) ' ========== '
-         IF(lwp) WRITE(numout,*)
-         IF( jpinf /= jpieob+1 .OR. jpjnob+1 /= jpjef ) &
-              &   CALL ctl_stop( ' Open boundaries do not fit, we stop' )
-       ELSE IF( icorner(3) == 1 ) THEN
-          CALL ctl_stop( ' Open boundaries do not fit at NE corner, we stop' )
-       END IF 
-
-      IF( icorner(4) == 2 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) ' North West ocean corner, two open boudaries'
-         IF(lwp) WRITE(numout,*) ' ========== '
-         IF(lwp) WRITE(numout,*)
-         IF( jpind /= jpiwob.OR.jpjnob+1 /= jpjwf ) &
-              &   CALL ctl_stop( ' Open boundaries do not fit, we stop' )
-       ELSE IF( icorner(4) == 1 ) THEN
-          CALL ctl_stop( ' Open boundaries do not fit at NW corner, we stop' )
-       END IF 
-
-      ! 6. Initialization of open boundary variables (u, v, t, s)
-      ! --------------------------------------------------------------
-      !   only if at least one boundary is  radiative 
-      IF ( inumfbc < nbobc .AND.  ln_rstart ) THEN
-         !  Restart from restart.obc
-         CALL obc_rst_read
-      ELSE
-
-!         ! ... Initialization to zero of radiation arrays.
-!         !     Those have dimensions of local subdomains
-
-          uebnd(:,:,:,:) = 0.e0   ;   unbnd(:,:,:,:) = 0.e0
-          vebnd(:,:,:,:) = 0.e0   ;   vnbnd(:,:,:,:) = 0.e0
-          tebnd(:,:,:,:) = 0.e0   ;   tnbnd(:,:,:,:) = 0.e0
-          sebnd(:,:,:,:) = 0.e0   ;   snbnd(:,:,:,:) = 0.e0
-
-          uwbnd(:,:,:,:) = 0.e0   ;   usbnd(:,:,:,:) = 0.e0
-          vwbnd(:,:,:,:) = 0.e0   ;   vsbnd(:,:,:,:) = 0.e0
-          twbnd(:,:,:,:) = 0.e0   ;   tsbnd(:,:,:,:) = 0.e0
-          swbnd(:,:,:,:) = 0.e0   ;   ssbnd(:,:,:,:) = 0.e0
-
-      END IF
-
-      ! 7. Control print
-      ! -----------------------------------------------------------------
-
-      ! ... control of the east boundary
-      IF( lp_obc_east ) THEN
-         istop = 0
-         IF( jpieob < 4 .OR.  jpieob >= jpiglo ) THEN
-            IF(lwp) WRITE(numout,cform_err)
-            IF(lwp) WRITE(numout,*) '            jpieob exceed ', jpim1, ' or less than 4'
-            istop = istop + 1
-         END IF
-
-         IF( lk_mpp ) THEN
-            ! ... 
-            IF( nimpp > jpieob-5) THEN
-               IF(lwp) WRITE(numout,cform_err)
-               IF(lwp) WRITE(numout,*) '        A sub-domain is too close to the East OBC'
-               IF(lwp) WRITE(numout,*) '        nimpp must be < jpieob-5'
-               istop = istop + 1
-            ENDIF
-         ELSE
-
-            ! ... stop if  e r r o r (s)   detected
-            IF( istop /= 0 ) THEN
-               WRITE(ctmp1,*) istop,' obcini : E R R O R (S) detected : stop'
-               CALL ctl_stop( ctmp1 )
-            ENDIF
-         ENDIF
-      ENDIF
-
-      ! ... control of the west boundary
-      IF( lp_obc_west ) THEN
-         istop = 0
-         IF( jpiwob < 2 .OR.  jpiwob >= jpiglo ) THEN
-            IF(lwp) WRITE(numout,cform_err)
-            IF(lwp) WRITE(numout,*) '            jpiwob exceed ', jpim1, ' or less than 2'
-            istop = istop + 1
-         END IF
-
-         IF( lk_mpp ) THEN
-            IF( (nimpp < jpiwob+5) .AND. (nimpp > 1) ) THEN
-               IF(lwp) WRITE(numout,cform_err)
-               IF(lwp) WRITE(numout,*) '        A sub-domain is too close to the West OBC'
-               IF(lwp) WRITE(numout,*) '        nimpp must be > jpiwob-5 or =1'
-               istop = istop + 1
-            ENDIF
-         ELSE
-   
-            ! ... stop if  e r r o r (s)   detected
-            IF( istop /= 0 ) THEN
-               WRITE(ctmp1,*) istop,' obcini : E R R O R (S) detected : stop'
-               CALL ctl_stop( ctmp1 )
-            ENDIF
-         ENDIF
-      ENDIF
-
-      ! control of the north boundary
-      IF( lp_obc_north ) THEN
-         istop = 0
-         IF( jpjnob < 4 .OR.  jpjnob >= jpjglo ) THEN
-            IF(lwp) WRITE(numout,cform_err)
-            IF(lwp) WRITE(numout,*) '          jpjnob exceed ', jpjm1,' or less than 4'
-            istop = istop + 1
-         END IF
-
-         IF( lk_mpp ) THEN
-            IF( njmpp > jpjnob-5) THEN
-               IF(lwp) WRITE(numout,cform_err)
-               IF(lwp) WRITE(numout,*) '        A sub-domain is too close to the North OBC'
-               IF(lwp) WRITE(numout,*) '        njmpp must be < jpjnob-5'
-               istop = istop + 1
-            ENDIF
-         ELSE
-   
-            ! ... stop if  e r r o r (s)   detected
-            IF( istop /= 0 ) THEN
-                WRITE(ctmp1,*) istop,' obcini : E R R O R (S) detected : stop'
-               CALL ctl_stop( ctmp1 )
-           ENDIF
-         ENDIF
-      ENDIF
-
-      ! control of the south boundary
-      IF( lp_obc_south ) THEN
-         istop = 0
-         IF( jpjsob < 2 .OR. jpjsob >= jpjglo ) THEN
-            IF(lwp) WRITE(numout,cform_err)
-            IF(lwp) WRITE(numout,*) '          jpjsob exceed ', jpjm1,' or less than 2'
-            istop = istop + 1
-         END IF
-
-         IF( lk_mpp ) THEN
-            IF( (njmpp < jpjsob+5) .AND. (njmpp > 1) ) THEN
-               IF(lwp) WRITE(numout,cform_err)
-               IF(lwp) WRITE(numout,*) '        A sub-domain is too close to the South OBC'
-               IF(lwp) WRITE(numout,*) '        njmpp must be > jpjsob+5 or =1'
-               istop = istop + 1
-            ENDIF
-         ELSE
-   
-            ! ... stop if  e r r o r (s)   detected
-            IF( istop /= 0 ) THEN
-               WRITE(ctmp1,*) istop,' obcini : E R R O R (S) detected : stop'
-               CALL ctl_stop( ctmp1 )
-            ENDIF
-         ENDIF
-      ENDIF
+         IF( icount /= 0 ) THEN
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) ' E R R O R : Some data velocity points,',   &
+               ' are not boundary points. Check nbi, nbj, indices for boundary set ',ib_obc
+            IF(lwp) WRITE(numout,*) ' ========== '
+            IF(lwp) WRITE(numout,*)
+            nstop = nstop + 1
+         ENDIF 
+    
+      ENDDO
+
+      ! Compute total lateral surface for volume correction:
+      ! ----------------------------------------------------
+      obcsurftot = 0.e0 
+      IF( ln_vol ) THEN  
+         igrd = 2      ! Lateral surface at U-points
+         DO ib_obc = 1, nb_obc
+            DO ib = 1, idx_obc(ib_obc)%nblenrim(igrd)
+               nbi => idx_obc(ib_obc)%nbi(ib,igrd)
+               nbj => idx_obc(ib_obc)%nbi(ib,igrd)
+               flagu => idx_obc(ib_obc)%flagu(ib)
+               obcsurftot = obcsurftot + hu     (nbi  , nbj)                           &
+                  &                    * e2u    (nbi  , nbj) * ABS( flagu ) &
+                  &                    * tmask_i(nbi  , nbj)                           &
+                  &                    * tmask_i(nbi+1, nbj)                   
+            ENDDO
+         ENDDO
+
+         igrd=3 ! Add lateral surface at V-points
+         DO ib_obc = 1, nb_obc
+            DO ib = 1, idx_obc(ib_obc)%nblenrim(igrd)
+               nbi => idx_obc(ib_obc)%nbi(ib,igrd)
+               nbj => idx_obc(ib_obc)%nbi(ib,igrd)
+               flagv => idx_obc(ib_obc)%flagv(ib)
+               obcsurftot = obcsurftot + hv     (nbi, nbj  )                           &
+                  &                    * e1v    (nbi, nbj  ) * ABS( flagv ) &
+                  &                    * tmask_i(nbi, nbj  )                           &
+                  &                    * tmask_i(nbi, nbj+1)
+            ENDDO
+         ENDDO
+         !
+         IF( lk_mpp )   CALL mpp_sum( obcsurftot )      ! sum over the global domain
+      END IF   
+
+      ! Read in tidal constituents and adjust for model start time
+      ! ----------------------------------------------------------
+!!$      IF( ln_tides )   CALL tide_data
+      !
+      ! Tidy up
+      !--------
+      DEALLOCATE(nbidta, nbjdta, nbrdta)
 
    END SUBROUTINE obc_init
